_SETTINGS:SetPlayerMenuOff()

-- Capture zone persistence
----------------------------------------------------------
SaveScheduleUnits = 60 --Seconds between each table write
----------------------------------------------------------
  
function IntegratedbasicSerialize(s)
    if s == nil then
		return "\"\""
    else
		if ((type(s) == 'number') or (type(s) == 'boolean') or (type(s) == 'function') or (type(s) == 'table') or (type(s) == 'userdata') ) then
			return tostring(s)
		elseif type(s) == 'string' then
			return string.format('%q', s)
		end
    end
end
  
-- imported slmod.serializeWithCycles (Speed)
function IntegratedserializeWithCycles(name, value, saved)
    local basicSerialize = function (o)
		if type(o) == "number" then
			return tostring(o)
		elseif type(o) == "boolean" then
			return tostring(o)
		else -- assume it is a string
			return IntegratedbasicSerialize(o)
		end
	end

    local t_str = {}
    saved = saved or {}       -- initial value
    if ((type(value) == 'string') or (type(value) == 'number') or (type(value) == 'table') or (type(value) == 'boolean')) then
		table.insert(t_str, name .. " = ")
			if type(value) == "number" or type(value) == "string" or type(value) == "boolean" then
				table.insert(t_str, basicSerialize(value) ..  "\n")
			else
				if saved[value] then    -- value already saved?
					table.insert(t_str, saved[value] .. "\n")
				else
					saved[value] = name   -- save name for next time
					table.insert(t_str, "{}\n")
						for k,v in pairs(value) do      -- save its fields
							local fieldname = string.format("%s[%s]", name, basicSerialize(k))
							table.insert(t_str, IntegratedserializeWithCycles(fieldname, v, saved))
						end
				end
			end
		return table.concat(t_str)
    else
		return ""
    end
end

function file_exists(name) --check if the file already exists for writing
	if lfs.attributes(name) then
    return true
    else
    return false end 
end

function writemission(data, file)--Function for saving to file (commonly found)
	File = io.open(file, "w")
	File:write(data)
	File:close()
end

function SEF_GetTableLength(Table)
	local TableLengthCount = 0
	for _ in pairs(Table) do TableLengthCount = TableLengthCount + 1 end
	return TableLengthCount
end

function SEF_SaveCaptureZoneTable(timeloop, time)
	persistenceStr = IntegratedserializeWithCycles("CAPZONE_STATUS", CAPZONE_STATUS)
	writemission(persistenceStr, "PendulumPersistence.lua")
	--trigger.action.outText("Progress Has Been Saved", 15)	
	return time + SaveScheduleUnits
end

-- Rescue Helo with home base Lake Erie. Has to be a global object!
rescuehelo=RESCUEHELO:New("BLUE CV STENNIS", "BLUE CV STENNIS RESCUE HELO")
rescuehelo:SetHomeBase(AIRBASE:FindByName("BLUE CV ANZIO"))
rescuehelo:SetModex(42)
rescuehelo:__Start(1)

local AirbossStennis=AIRBOSS:New("BLUE CV STENNIS")
AirbossStennis:AddRecoveryWindow("5:50", "6:50", 1, nil, true, 20)
AirbossStennis:AddRecoveryWindow("7:50", "9:50", 1, nil, true, 20)
AirbossStennis:AddRecoveryWindow("10:50", "12:50", 1, nil, true, 20)
AirbossStennis:AddRecoveryWindow("13:50", "15:50", 1, nil, true, 20)
AirbossStennis:AddRecoveryWindow("16:50", "18:50", 1, nil, true, 20)
AirbossStennis:AddRecoveryWindow("19:50", "21:50", 1, nil, true, 20)
AirbossStennis:AddRecoveryWindow("22:50", "23:50", 1, nil, true, 20)
AirbossStennis:SetSoundfilesFolder("Airboss Soundfiles/")
AirbossStennis:SetTACAN(74, "X", "STN")
AirbossStennis:SetICLS(11, "STN")
AirbossStennis:SetMenuMarkZones(false)
AirbossStennis:SetMenuSmokeZones(false)
AirbossStennis:SetPatrolAdInfinitum(true)
AirbossStennis:Start()

-- CONSTANTS *************************************************************************************

CAPTURE_ZONE_NAMES = {"GALI ZONE", "SUKHUMI ZONE", "GUDAUTA ZONE"}

CaucasusPendulum = {}
CaucasusPendulum.radioMenusAdded = {}

-- CAP speeds
CaucasusPendulum.minInterceptSpeed = 650
CaucasusPendulum.maxInterceptSpeed = 900

-- map marker flags, don't edit
CaucasusPendulum.mapMarkRedBarracks = 0
CaucasusPendulum.mapMarkBlueCommandPost = 0
CaucasusPendulum.mapMarkRedAmmuntionDepot = 0
CaucasusPendulum.mapMarkRedGaliAssault = 0

-- BLUE GROUPS SHOOT RED FLARES (faking RED field observers here)
function blueGroupFlare(MooseGroup)
  local FLARE_SCHEDULER = SCHEDULER:New(nil,
  function()
    if MooseGroup:IsAlive() ~= nil then
      MooseGroup:FlareRed()
    end
  end, {}, 30, 90, 0 )
end

-- SAM SPAWNING ***************************************************************************************

-- RED SAMS
RedSochiSA6SpawnZones = { 
	ZONE:FindByName( "RED SOCHI SA6 SPAWN ZONE1" ), 
	ZONE:FindByName( "RED SOCHI SA6 SPAWN ZONE2" ),
	ZONE:FindByName( "RED SOCHI SA6 SPAWN ZONE3" ),
	ZONE:FindByName( "RED SOCHI SA6 SPAWN ZONE4" ),
	ZONE:FindByName( "RED SOCHI SA6 SPAWN ZONE5" ),
	ZONE:FindByName( "RED SOCHI SA6 SPAWN ZONE6" )}
RED_SOCHI_SA6 = SPAWN
	:New( "RED SOCHI SA6" )
	:InitLimit(8,0)
	:InitRandomizeZones( RedSochiSA6SpawnZones )
	:SpawnScheduled(600, 1)
RED_SOCHI_SAM = SPAWN
	:New( "RED SOCHI SAM" )
	:InitLimit(12,0)
	:InitRandomizeZones( RedSochiSA6SpawnZones )
	:SpawnScheduled(600, 1)
RED_SOCHI_AIRPORT_AAA = SPAWN
	:New( "RED SOCHI AIRPORT AAA" )
	:InitLimit(12,0)
	:SpawnScheduled(600, 1)
RED_GUDAUTA_SA11_SPAWN_ZONES = { 
	ZONE:FindByName( "RED SA11 SPAWN1" ), 
	ZONE:FindByName( "RED SA11 SPAWN2" ),
	ZONE:FindByName( "RED SA11 SPAWN3" ),
	ZONE:FindByName( "RED SA11 SPAWN4" )}
RED_GUDAUTA_SA11 = SPAWN
	:New( "RED GUDAUTA SA11" )
	:InitLimit(4,0)
	:InitRandomizeZones( RED_GUDAUTA_SA11_SPAWN_ZONES )
RED_GUDAUTA_SAM = SPAWN
	:New( "RED GUDAUTA SAM" )
	:InitLimit(3,0)
	:InitRandomizeZones( RED_GUDAUTA_SA11_SPAWN_ZONES )

-- BLUE SAMS
BLUE_POTI_SAM = SPAWN
	:New( "BLUE POTI SAM" )
	:InitLimit(12,0)
	:SpawnScheduled(600, 1)
BLUE_KUTAISI_SAM = SPAWN
	:New( "BLUE KUTAISI SAM" )
	:InitLimit(12,0)
	:SpawnScheduled(600, 1)
BLUE_ZUGDIDI_SA3 = SPAWN
	:New( "BLUE ZUGDIDI SA3")
	:InitLimit(10, 0)
	:SpawnScheduled(600, 1)
BLUE_ZUGDIDI_AAA = SPAWN
	:New( "BLUE ZUGDIDI AAA" )
	:InitLimit(4, 0)
	:SpawnScheduled(600, 1)
-- BLUE KOBULETI AIRPORT
BLUE_KOBULETI_HAWK = SPAWN
  	:New( "BLUE KOBULETI HAWK" )
	:InitLimit(7,0)
  	:SpawnScheduled(600, 1)
BLUE_KOBULETI_AIRPORT_AAA = SPAWN
	:New( "BLUE KOBULETI AIRPORT AAA" )
	:InitLimit(6,0)
	:SpawnScheduled(600, 1)

env.info("Syria Pendulum SAM SPAWNING loaded ...")
trigger.action.outText("Syria Pendulum SAM SPAWNING loaded ...", 10)

-- CAS SPAWNS *******************************************

RED_AI_CAS = SPAWN
	:New( "RED CAS SU-25" )
	:InitLimit(1,0)
	:OnSpawnGroup(
		function (casGroup)
			casGroup:HandleEvent(EVENTS.Land)
			function casGroup:OnEventLand(EventData)
			    casGroup:Destroy()
			 end
		end
		)

BLUE_AI_CAS = SPAWN
	:New( "BLUE CAS GALI" )
	:InitLimit(1,0)
	:OnSpawnGroup(
		function (casGroup)

			local GALI_CAS_ENGANGEMENT_ZONE = ZONE:New( "GALI ZONE" )
		    local GALI_CAS_PATROL_ZONE = ZONE:New( "BLUE CAP LOITER ZONE" )
		    GALI_CAS_ZONE = AI_CAS_ZONE:New( GALI_CAS_PATROL_ZONE, 500, 2000, 400, 650, GALI_CAS_ENGANGEMENT_ZONE )
		    GALI_CAS_ZONE:SetControllable( casGroup )
		    GALI_CAS_ZONE:__Start( 1 )
		    GALI_CAS_ZONE:__Engage( 5, 700, 2000 )

			casGroup:HandleEvent(EVENTS.Land)
			function casGroup:OnEventLand(EventData)
			    casGroup:Destroy()
			 end
		end
		)

env.info("Syria Pendulum CAS SPAWNS loaded ...")
trigger.action.outText("Syria Pendulum CAS SPAWNS loaded ...", 10)

-- AWACS ***************************************************************************************

BLUE_AWACS = SPAWN
	:New( "BLUE AWACS OVERLORD" )
	:InitLimit(1,0)
	:OnSpawnGroup(
		function(MooseGroup)
			MooseGroup:HandleEvent(EVENTS.Land)

			function MooseGroup:OnEventLand(EventData)
		        MooseGroup:Destroy()
		    end
		end
	)
	:SpawnScheduled(900, 1)

RED_AWACS = SPAWN
	:New( "RED AWACS" )
	:InitLimit(1,0)
	:OnSpawnGroup(
		function(MooseGroup)
			MooseGroup:HandleEvent(EVENTS.Land)

			function MooseGroup:OnEventLand(EventData)
		        MooseGroup:Destroy()
		    end
		end)
	:SpawnScheduled(900, 1)

-- FAC ***************************************************************************************

-- POINTER FAC
BLUE_FAC_POINTER = SPAWN
	:New("BLUE FAC POINTER")
	:InitLimit(1, 0)
	:OnSpawnGroup(
		function (facGroup) 
		  
			ctld.JTACAutoLase(facGroup:GetName(), 1651, false, "vehicle")
			env.info("JTAC START " .. facGroup:GetName())
			trigger.action.outTextForCoalition(2, "POINTER heading to Zone Charlie", 10)
			trigger.action.outSoundForCoalition(2, "walkietalkie.ogg" )
			 
			facGroup:HandleEvent(EVENTS.Dead)
			facGroup:HandleEvent(EVENTS.Land)
			 
			function facGroup:OnEventDead(EventData)
			   ctld.JTACAutoLaseStop(EventData.IniGroupName)
			   env.info("JTAC STOP " .. EventData.IniGroupName) 
			end

			function facGroup:OnEventLand(EventData)
		       facGroup:Destroy()
		    end
		end)
	:SpawnScheduled(120, 1)

 -- AXEMAN FAC
BLUE_FAC_AXEMAN = SPAWN
	:New("BLUE FAC AXEMAN")
	:InitLimit(1, 0)
	:OnSpawnGroup(
	function (facGroup) 
	    
	   ctld.JTACAutoLase(facGroup:GetName(), 1652, false, "vehicle")
	   env.info("JTAC START " .. facGroup:GetName()) 
	   trigger.action.outTextForCoalition(2, "AXEMAN heading to Zone Bravo", 10)
	   trigger.action.outSoundForCoalition(2, "walkietalkie.ogg" )
	    
	   facGroup:HandleEvent(EVENTS.Dead)
	   facGroup:HandleEvent(EVENTS.Land)
	    
	   function facGroup:OnEventDead(EventData)
	      ctld.JTACAutoLaseStop(EventData.IniGroupName)
	      env.info("JTAC STOP " .. EventData.IniGroupName) 
	   end

	   function facGroup:OnEventLand(EventData)
            facGroup:Destroy()
         end
	end)

-- TODO REPLACE WITH MOOSE DESIGNATION?
--BLUE_HQ = GROUP:FindByName( "BLUE HQ" )
--BLUE_CC = COMMANDCENTER:New( BLUE_HQ, "BLUE HQ" )
--BLUE_FAC_GROUP = SET_GROUP:New():FilterPrefixes( "BLUE FAC" ):FilterStart()
--BLUE_FAC_DETECTION = DETECTION_UNITS:New( BLUE_FAC_GROUP ):FilterCategories( Unit.Category.GROUND_UNIT )
--BLUE_FAC_PLAYERS = SET_GROUP:New():FilterPrefixes("BLUE PLAYER"):FilterStart()
--BLUE_FAC_DESIGNATION = DESIGNATE:New( BLUE_CC, BLUE_FAC_DETECTION, BLUE_FAC_PLAYERS )
--BLUE_FAC_DESIGNATION:SetThreatLevelPrioritization( true )
--BLUE_FAC_DESIGNATION:GenerateLaserCodes()
--BLUE_FAC_DESIGNATION:SetMaximumDesignations(2)
--BLUE_FAC_DETECTION:__Detect(5)

env.info("Syria Pendulum JTAC loaded ...")
trigger.action.outText("Syria Pendulum JTAC loaded ...", 10)

-- CAPTURE ZONES ***************************************************************************************

-- DEFINE UNITS
-- GALI UNITS
GaliSpawnZones = { 
  ZONE:FindByName( "GALI SPAWN ZONE-1" ), 
  ZONE:FindByName( "GALI SPAWN ZONE-2" ),
  ZONE:FindByName( "GALI SPAWN ZONE-3" ),
  ZONE:FindByName( "GALI SPAWN ZONE-4" ),
  ZONE:FindByName( "GALI SPAWN ZONE-5" ), 
  ZONE:FindByName( "GALI SPAWN ZONE-6" ),
  ZONE:FindByName( "GALI SPAWN ZONE-7" ),
  ZONE:FindByName( "GALI SPAWN ZONE-8" ),
  ZONE:FindByName( "GALI SPAWN ZONE-9" ),
  ZONE:FindByName( "GALI SPAWN ZONE-10" )}

BLUE_GALI_ASSAULT = SPAWN
	:New("BLUE GALI ASSAULT")
	:InitKeepUnitNames( true )
	:InitLimit(8,0)
	:InitRandomizeZones( GaliSpawnZones )
	:OnSpawnGroup(
		function(MooseGroup)
			trigger.action.outText("BLUE columm in Zone Charlie", 10 , false)
			trigger.action.outSound("walkietalkie.ogg" )
		 	blueGroupFlare(MooseGroup)
		end)
	:SpawnScheduled(300, 1) -- THIS UNIT IS SCHEDULED, DON'T USE Spawn() with it

RED_GALI_ASSAULT = SPAWN
	:New( "RED GALI ASSAULT" )
	:InitKeepUnitNames( true )
	:InitLimit(8,0)
	:InitRandomizeZones( GaliSpawnZones )
	:OnSpawnGroup(
		function(MooseGroup)
			trigger.action.outText("RED columm in Zone Charlie", 10 , false)
			trigger.action.outSound("walkietalkie.ogg" )

			local MooseGroupCoordinate = MooseGroup:GetCoordinate()
		  	local markId = MooseGroupCoordinate:MarkToAll("RED Zone Charlie Assault Column\nBLUE: Attack\nRED: Protect", true, nil)
		  	CaucasusPendulum.mapMarkRedGaliAssault = markId

		  	MooseGroup:HandleEvent(EVENTS.Dead)	  

			function MooseGroup:OnEventDead(EventData)
			 	if MooseGroup:GetSize() == 1 then
			 		trigger.action.removeMark( CaucasusPendulum.mapMarkRedGaliAssault )
			 	end
			end
		end)
	
-- SUKHUMI COLUMNS
BLUE_SUKHUMI_SUPPORT = SPAWN
	:New( "BLUE SUKHUMI SUPPORT" )
	:InitKeepUnitNames( true )
	:InitLimit(15,0)
	:InitRandomizeRoute(4, 0, 200)
	:OnSpawnGroup(
		function(MooseGroup)
			trigger.action.outText("BLUE columm heading to Zone Bravo", 10 , false)
			trigger.action.outSound("walkietalkie.ogg" )
			blueGroupFlare(MooseGroup)
		end)

RED_SUKHUMI_SUPPORT = SPAWN
	:New( "RED SUKHUMI SUPPORT" )
	:InitKeepUnitNames( true )
	:InitLimit(15,0)
	:InitRandomizeRoute(7, 0, 200)
	:OnSpawnGroup(
		function(MooseGroup)
			trigger.action.outText("RED columm heading to Zone Bravo", 10 , false)
			trigger.action.outSound("walkietalkie.ogg" )
		end)

-- GUDAUTA COLUMNS
BLUE_GUDAUTA_SUPPORT = SPAWN
	:New( "BLUE GUDAUTA SUPPORT" )
	:InitKeepUnitNames( true )
	:InitLimit(15,0)
	:InitRandomizeRoute(4, 0, 200)
	:OnSpawnGroup(
		function(MooseGroup)
			trigger.action.outText("BLUE columm heading to Zone Alpha", 10 , false)
			trigger.action.outSound("walkietalkie.ogg" )
			blueGroupFlare(MooseGroup)
		end)

RED_GUDAUTA_SUPPORT = SPAWN
	:New( "RED GUDAUTA SUPPORT" )
	:InitKeepUnitNames( true )
	:InitLimit(10,0)
	:InitRandomizeRoute(4, 0, 200)
	:OnSpawnGroup(
		function(MooseGroup)
			trigger.action.outText("RED columm heading to Zone Alpha", 10 , false)
			trigger.action.outSound("walkietalkie.ogg" )
		end)
	:SpawnScheduled(300, 1) -- THIS UNIT IS SCHEDULED, DON'T USE Spawn() with it

-- SPAWN SOME AT MISSION START
RED_SUKHUMI_SUPPORT:Spawn()
RED_GALI_ASSAULT:Spawn()

if file_exists("PendulumPersistence.lua") then
	dofile("PendulumPersistence.lua")
else
	CAPZONE_STATUS = {}
	CAPZONE_STATUS.ALPHA = coalition.side.RED
	CAPZONE_STATUS.BRAVO = coalition.side.RED
	CAPZONE_STATUS.CHARLIE = coalition.side.RED
end

-- Persistence: Define Capture Zones
GaliZone = ZONE:FindByName( "GALI ZONE" )
GaliCaptureZone = ZONE_CAPTURE_COALITION:New( GaliZone, CAPZONE_STATUS.CHARLIE )
SukhumiZone = ZONE:FindByName( "SUKHUMI ZONE" )
SukhumiCaptureZone = ZONE_CAPTURE_COALITION:New( SukhumiZone, CAPZONE_STATUS.BRAVO )
GudautaZone = ZONE:FindByName( "GUDAUTA ZONE" )
GudautaCaptureZone = ZONE_CAPTURE_COALITION:New( GudautaZone, CAPZONE_STATUS.ALPHA )

-- Persistence: Scheduler
timer.scheduleFunction(SEF_SaveCaptureZoneTable, 53, timer.getTime() + SaveScheduleUnits)

-- Define Schedulers
BLUE_GROUND_UNITS_SCHEDULER = SCHEDULER:New(nil,
	function()
		if (GaliCaptureZone:GetCoalition() == coalition.side.BLUE) then
			BLUE_FAC_AXEMAN:Spawn()
			BLUE_SUKHUMI_SUPPORT:Spawn()
			RED_AI_CAS:Spawn()
		end
		if (SukhumiCaptureZone:GetCoalition() == coalition.side.BLUE) then
			BLUE_GUDAUTA_SUPPORT:Spawn()
		end
		if (GudautaCaptureZone:GetCoalition() == coalition.side.BLUE) then
			BLUE_SUKHUMI_SUPPORT:Spawn()
			BLUE_GUDAUTA_SUPPORT:Spawn()
		end
	end,
	{}, 5, 300, 0.3)

RED_GROUND_UNITS_SCHEDULER = SCHEDULER:New(nil,
	function()
		if (GudautaCaptureZone:GetCoalition() == coalition.side.RED) then
			RED_SUKHUMI_SUPPORT:Spawn()
		end
		if (SukhumiCaptureZone:GetCoalition() == coalition.side.RED) then
			RED_GALI_ASSAULT:Spawn()
		end
		if (GaliCaptureZone:GetCoalition() == coalition.side.RED) then
			RED_GALI_ASSAULT:Spawn()
			RED_SUKHUMI_SUPPORT:Spawn()
			BLUE_AI_CAS:Spawn()
		end
	end,
	{}, 5, 300, 0.3)

RED_GUDAUTA_SAM_SCHEDULER = SCHEDULER:New(nil,
	function()
		if (GudautaCaptureZone:GetCoalition() == coalition.side.RED) then
			RED_GUDAUTA_SA11:Spawn()
			RED_GUDAUTA_SAM:Spawn()
		end
	end,
	{}, 5, 1800, 0.5)

-- GALI
--- @param Functional.Protect#ZONE_CAPTURE_COALITION self
function GaliCaptureZone:OnEnterAttacked()
  local Coalition = self:GetCoalition()
  self:E({Coalition = Coalition})
  if Coalition == coalition.side.BLUE then
    trigger.action.outText("RED coalition attacking Zone Charlie", 10 , false)
	trigger.action.outSound("walkietalkie.ogg" )
  else
    trigger.action.outText("BLUE coalition attacking Zone Charlie", 10 , false)
	trigger.action.outSound("walkietalkie.ogg" )
  end
end

--- @param Functional.Protect#ZONE_CAPTURE_COALITION self
function GaliCaptureZone:OnEnterCaptured()
  trigger.action.outSound("walkietalkie2.ogg" )
  local Coalition = self:GetCoalition()
  self:E({Coalition = Coalition})
  CAPZONE_STATUS.CHARLIE = Coalition
  if Coalition == coalition.side.BLUE then
    trigger.action.outText("BLUE coalition captured Zone Charlie", 10 , false)
	trigger.action.outSound("walkietalkie.ogg" )
  else
    trigger.action.outText("RED coalition captured Zone Charlie", 10 , false)
	trigger.action.outSound("walkietalkie.ogg" )
  end
   
  self:__Guard( 30 )
end

GaliCaptureZone:__Guard( 1 )
GaliCaptureZone:Start( 30, 120 )

-- SUKHUMI
--- @param Functional.Protect#ZONE_CAPTURE_COALITION self
function SukhumiCaptureZone:OnEnterAttacked()
  local Coalition = self:GetCoalition()
  self:E({Coalition = Coalition})
  if Coalition == coalition.side.BLUE then
    trigger.action.outText("RED coalition attacking Zone Bravo", 10 , false)
	trigger.action.outSound("walkietalkie.ogg" )
  else
    trigger.action.outText("BLUE coalition attacking Zone Bravo", 10 , false)
	trigger.action.outSound("walkietalkie.ogg" )
  end
end

--- @param Functional.Protect#ZONE_CAPTURE_COALITION self
function SukhumiCaptureZone:OnEnterCaptured()
  trigger.action.outSound("walkietalkie2.ogg" )
  local Coalition = self:GetCoalition()
  self:E({Coalition = Coalition})
  CAPZONE_STATUS.BRAVO = Coalition
  if Coalition == coalition.side.BLUE then
    trigger.action.outText("BLUE coalition captured Zone Bravo", 10 , false)
	trigger.action.outSound("walkietalkie.ogg" )
  else
    trigger.action.outText("RED coalition captured Zone Bravo", 10 , false)
	trigger.action.outSound("walkietalkie.ogg" )
  end
   
  self:__Guard( 30 )
end

SukhumiCaptureZone:__Guard( 1 )
SukhumiCaptureZone:Start( 30, 120 )

-- GUDAUTA BASE
--- @param Functional.Protect#ZONE_CAPTURE_COALITION self
function GudautaCaptureZone:OnEnterAttacked()
  local Coalition = self:GetCoalition()
  self:E({Coalition = Coalition})
  if Coalition == coalition.side.BLUE then
    trigger.action.outText("RED coalition attacking Zone Alpha", 10 , false)
	trigger.action.outSound("walkietalkie.ogg" )
  else
    trigger.action.outText("BLUE coalition attacking Zone Alpha", 10 , false)
	trigger.action.outSound("walkietalkie.ogg" )
  end
end

--- @param Functional.Protect#ZONE_CAPTURE_COALITION self
function GudautaCaptureZone:OnEnterCaptured()
  trigger.action.outSound("walkietalkie2.ogg" )
  local Coalition = self:GetCoalition()
  self:E({Coalition = Coalition})
  CAPZONE_STATUS.ALPHA = Coalition
  if Coalition == coalition.side.BLUE then
	trigger.action.outText("BLUE coalition captured Zone Alpha", 10 , false)
	trigger.action.outSound("walkietalkie.ogg" )
  else
	trigger.action.outText("RED coalition captured Zone Alpha", 10 , false)
	trigger.action.outSound("walkietalkie.ogg" )
  end
   
  self:__Guard( 30 )
end

GudautaCaptureZone:__Guard( 1 )
GudautaCaptureZone:Start( 30, 120 )

env.info("Syria Pendulum CAPTURE ZONES loaded ...")
trigger.action.outText("Syria Pendulum CAPTURE ZONES loaded ...", 10)

-- STRATEGIC TARGETS ***************************************************************************************

RED_BARRACKS_ZONES = { 
	ZONE:FindByName( "RED BARRACKS ZONE1" ),
	ZONE:FindByName( "RED BARRACKS ZONE2" ),
	ZONE:FindByName( "RED BARRACKS ZONE3" ),
	ZONE:FindByName( "RED BARRACKS ZONE4" ),
	ZONE:FindByName( "RED BARRACKS ZONE5" ),
	ZONE:FindByName( "RED BARRACKS ZONE6" )}

BLUE_COMMAND_POST_ZONES = {
	ZONE:FindByName("BLUE COMMAND POST ZONE1"),
	ZONE:FindByName("BLUE COMMAND POST ZONE2"),
	ZONE:FindByName("BLUE COMMAND POST ZONE3"),
	ZONE:FindByName("BLUE COMMAND POST ZONE4"),
	ZONE:FindByName("BLUE COMMAND POST ZONE5"),
	ZONE:FindByName("BLUE COMMAND POST ZONE6")}

function CaucasusPendulum.spawnRedBarracks()
	RED_BARRACKS = SPAWN
		:New( "RED BARRACKS" )
		:InitRandomizeZones( RED_BARRACKS_ZONES )
		:OnSpawnGroup(
		function( MooseGroup )
		  local MooseGroupCoordinate = MooseGroup:GetCoordinate()
		  local markId = MooseGroupCoordinate:MarkToAll("Military Barracks\nBLUE: Attack\nRED: Protect", true, nil)
		  CaucasusPendulum.mapMarkRedBarracks = markId

		  RED_GROUND_UNITS_SCHEDULER:Start()
		  trigger.action.outText("RED Military Barracks Repaired, see map.", 10)
		  trigger.action.outSound("walkietalkie.ogg" )

		  MooseGroup:HandleEvent(EVENTS.Dead)	  

		 function MooseGroup:OnEventDead(EventData)
		 	if RED_BARRACKS:GetSize() == 9 then
		 		trigger.action.removeMark( CaucasusPendulum.mapMarkRedBarracks )
			 	RED_GROUND_UNITS_SCHEDULER:Stop()
			 	RED_BARRACKS:Destroy( false )
			 	trigger.action.outText("RED Military Barracks attacked, no ground units for 30 minutes.", 10)
			    trigger.action.outSound("walkietalkie.ogg" )
			    timer.scheduleFunction(CaucasusPendulum.spawnRedBarracks, {}, timer.getTime() + 1800)
		 	end
		  end
		end)
		:Spawn()
end

function CaucasusPendulum.spawnBlueCommandOutpost()
	BLUE_COMMAND_POST = SPAWN
		:New( "BLUE COMMAND POST" )
		:InitRandomizeZones( BLUE_COMMAND_POST_ZONES )
		:OnSpawnGroup(
		function( MooseGroup )
		  local MooseGroupCoordinate = MooseGroup:GetCoordinate()
		  local markId = MooseGroupCoordinate:MarkToAll("Command Outpost\nBLUE: Protect\nRED: Attack", true, nil)
		  CaucasusPendulum.mapMarkBlueCommandPost = markId

		  BLUE_GROUND_UNITS_SCHEDULER:Start()
		  trigger.action.outText("BLUE Command Post recon data available, see map.", 10)
		  trigger.action.outSound("walkietalkie.ogg" )

		  MooseGroup:HandleEvent(EVENTS.Dead)

		  function MooseGroup:OnEventDead(EventData)
		  	if BLUE_COMMAND_POST:GetSize() == 4 then
		  		trigger.action.removeMark( CaucasusPendulum.mapMarkBlueCommandPost )
			 	BLUE_GROUND_UNITS_SCHEDULER:Stop()
			 	BLUE_COMMAND_POST:Destroy( false )
			 	trigger.action.outText("BLUE Command Outpost destroyed, no ground units for 30 minutes.", 10)
			    trigger.action.outSound("walkietalkie.ogg" )
			    timer.scheduleFunction(CaucasusPendulum.spawnBlueCommandOutpost, {}, timer.getTime() + 1800)
		  	end
		 end
		end)
		:Spawn()
end

-- RED GUDAUTA AMMUNITION DEPOT
RED_AMMUNITION_DEPOT = STATIC:FindByName("RED AMMUNITION DEPOT", false)
local RED_AMMUNITION_DEPOT_COORDINATE = RED_AMMUNITION_DEPOT:GetCoordinate()
local RED_AMMUNINTION_DEPOT_MAP_MARK_ID = RED_AMMUNITION_DEPOT_COORDINATE:MarkToAll("Ammunition Depot\nBLUE: Attack\nRED: Protect", true, nil)
CaucasusPendulum.mapMarkRedAmmuntionDepot = RED_AMMUNINTION_DEPOT_MAP_MARK_ID
RED_GUDAUTA_SAM_SCHEDULER:Start()

RED_AMMUNITION_DEPOT_SCHEDULER = SCHEDULER:New(nil,
	function()
		local redAmmuntionDepot = STATIC:FindByName("RED AMMUNITION DEPOT", false)
		if not redAmmuntionDepot:IsAlive() or redAmmuntionDepot == nil then
			trigger.action.removeMark( RED_AMMUNINTION_DEPOT_MAP_MARK_ID )
		 	trigger.action.outText("RED Ammuntion Depot destroyed, no SAM reinforcements in Zone Alpha will be available.", 10)
			trigger.action.outSound("walkietalkie.ogg" )
		 	RED_GUDAUTA_SAM_SCHEDULER:Stop()
			self:Stop()
		end
	end, {}, 0, 60, 0 )

-- COORDINATES FUNCTIONS

function CaucasusPendulum.getBlueCommandCenterCoords(groupId)
	local blueCommandPostCoordinates = BLUE_COMMAND_POST:GetCoordinate()
	if blueCommandPostCoordinates ~= nil then
		coordinatesLLDMS = blueCommandPostCoordinates:ToStringLLDMS(nil)
		coordinateMGRS = blueCommandPostCoordinates:ToStringMGRS(nil)
		coordinateElevation = blueCommandPostCoordinates:GetLandHeight()
		trigger.action.outTextForGroup(groupId, "Command Post Coordinates\n" .. coordinatesLLDMS .. "\n" .. coordinateMGRS .. "\nElevation: " .. math.ceil(coordinateElevation * 3.3) .. "ft", 30 , false)
		trigger.action.outSoundForGroup(groupId, "walkietalkie2.ogg")
	else
		trigger.action.outTextForGroup(groupId, "Target Destroyed", 30 , false)
		trigger.action.outSoundForGroup(groupId, "walkietalkie2.ogg")
	end
end

function CaucasusPendulum.getRedAmmoDepotCoords(groupId)
	local redAmmuntionDepot = STATIC:FindByName("RED AMMUNITION DEPOT", false)
	if redAmmuntionDepot:IsAlive() or redAmmuntionDepot == nil then
		local redAmmoDepotCoordinates = RED_AMMUNITION_DEPOT:GetCoordinate()
		coordinatesLLDMS = redAmmoDepotCoordinates:ToStringLLDMS(nil)
		coordinatesLLDDM = redAmmoDepotCoordinates:ToStringLLDDM(nil)
		coordinateMGRS = redAmmoDepotCoordinates:ToStringMGRS(nil)
		coordinateElevation = redAmmoDepotCoordinates:GetLandHeight()
		trigger.action.outTextForGroup(groupId, "Zone Alpha Ammunition Depot Coordinates\n" .. coordinatesLLDMS .. "\n" .. coordinatesLLDDM .."\n" .. coordinateMGRS .. "\nElevation: " .. math.ceil(coordinateElevation * 3.3) .. "ft", 30 , false)
		trigger.action.outSoundForGroup(groupId, "walkietalkie2.ogg")
	else
		trigger.action.outTextForGroup(groupId, "Target Destroyed", 30 , false)
		trigger.action.outSoundForGroup(groupId, "walkietalkie2.ogg")
	end
end

function CaucasusPendulum.getRedMilitaryBarracksCoords(groupId)
	local redBarrackCoordinates = RED_BARRACKS:GetCoordinate()
	if redBarrackCoordinates ~= nil then
		coordinatesLLDMS = redBarrackCoordinates:ToStringLLDMS(nil)
		coordinateMGRS = redBarrackCoordinates:ToStringMGRS(nil)
		coordinatesLLDDM = redBarrackCoordinates:ToStringLLDDM(nil)
		coordinateElevation = redBarrackCoordinates:GetLandHeight()
		trigger.action.outTextForGroup(groupId, "Military Barracks Coordinates\n" .. coordinatesLLDMS .. "\n" .. coordinatesLLDDM .."\n" .. coordinateMGRS .. "\nElevation: " .. math.ceil(coordinateElevation * 3.3) .. "ft", 30 , false)
		trigger.action.outSoundForGroup(groupId, "walkietalkie2.ogg")
	else
		trigger.action.outTextForGroup(groupId, "Target Destroyed", 30 , false)
		trigger.action.outSoundForGroup(groupId, "walkietalkie2.ogg")
	end
end

CaucasusPendulum.spawnRedBarracks()
CaucasusPendulum.spawnBlueCommandOutpost()

env.info("Syria Pendulum STRATEGIC TARGETS loaded ...")
trigger.action.outText("Syria Pendulum STRATEGIC TARGETS loaded ...", 10)

-- CHECK AIRBASE STATUS FUNCTIONS ***************************************************************************************

function CaucasusPendulum.getCaptureZoneStatus(_groupId)
	local GaliCoalition = GaliCaptureZone:GetCoalition()
	local SukhumiCoalition = SukhumiCaptureZone:GetCoalition()
	local GudautaCoalition = GudautaCaptureZone:GetCoalition()

	if GaliCoalition == coalition.side.BLUE then
		trigger.action.outTextForGroup(_groupId, "Zone Charlie is BLUE", 10 , false)
	else
		trigger.action.outTextForGroup(_groupId, "Zone Charlie is RED", 10 , false)
	end

	if SukhumiCoalition == coalition.side.BLUE then
		trigger.action.outTextForGroup(_groupId, "Zone Bravo is BLUE", 10 , false)
	else
		trigger.action.outTextForGroup(_groupId, "Zone Bravo is RED", 10 , false)
	end

	if GudautaCoalition == coalition.side.BLUE then
		trigger.action.outTextForGroup(_groupId, "Zone Alpha is BLUE", 10 , false)
	else
		trigger.action.outTextForGroup(_groupId, "Zone Alpha is RED", 10 , false)
	end

	trigger.action.outSoundForGroup(_groupId, "walkietalkie.ogg")
end

env.info("Syria Pendulum CAPTURE ZONE STATUS FUNCTIONS loaded ...")
trigger.action.outText("Syria Pendulum CAPTURE ZONE STATUS FUNCTIONS loaded ...", 10)

-- LIST RADIO FREQUENCIES FUNCTIONS ***************************************************************************************

function CaucasusPendulum.listRadioFrequencies(_groupId)
  local SukhumiCoalition = SukhumiCaptureZone:GetCoalition()
  local GudautaCoalition = GudautaCaptureZone:GetCoalition()

  trigger.action.outTextForGroup(_groupId, 
    [[
    BLUE COALITION
    AWACS AI - Overlord - 251 MHz
    TANKER - Texaco - 252 MHz - TCN 99X
    CVN-74 John C. Stennis - 127.5 MHz - TCN 74X - ICLS 11
    LHA-Tarawa - 127.5 MHz - TCN 99X
    ****
    CAP FLIGHTS: 300 MHz
    CAS FLIGHTS: 310 MHz
    ****
    CAP: Enfield/Springfield/Uzi/Colt
    CAS: Ford/Dodge/Pig/Hawg
    JTAC: Pontiac
    ****
    ROME FARP - 140 MHz - BCN 40 MHz
    MADRID FARP - 141 MHz - BCN 41 MHz
    ***
    Kobuleti 133/262 MHz
    ILS 111.50 MHz CRS 70
    TCN 67X
    ****
    RED COALITION
    AWACS AI - Callsign 50 - 124 MHz
    ]]
    , 15 , false)  
  trigger.action.outSoundForGroup(_groupId, "walkietalkie.ogg")
end

-- ADD RADIO MENUS ***************************************************************************************

function CaucasusPendulum.addRadioMenus(_side)

  local _players = coalition.getPlayers(_side)

    if _players ~= nil then
        for _, _playerUnit in pairs(_players) do
          local _groupId = ctld.getGroupId(_playerUnit)
          if _groupId then
              if CaucasusPendulum.radioMenusAdded[tostring(_groupId)] == nil then
              	local strategicTargetsMenuRootPath = missionCommands.addSubMenuForGroup(_groupId, "Strategic Targets")
              	if _side == coalition.side.RED then
		        	missionCommands.addCommandForGroup(_groupId, "Command Post", strategicTargetsMenuRootPath, CaucasusPendulum.getBlueCommandCenterCoords, _groupId)
		        end
		        if _side == coalition.side.BLUE then
		            missionCommands.addCommandForGroup(_groupId, "Ammunition Depot", strategicTargetsMenuRootPath, CaucasusPendulum.getRedAmmoDepotCoords, _groupId)
		            missionCommands.addCommandForGroup(_groupId, "Military Barracks", strategicTargetsMenuRootPath, CaucasusPendulum.getRedMilitaryBarracksCoords, _groupId)
		        end
                missionCommands.addCommandForGroup(_groupId, "List Radio Frequencies", nil, CaucasusPendulum.listRadioFrequencies, _groupId)
                missionCommands.addCommandForGroup(_groupId, "Capture Zone Status", nil, CaucasusPendulum.getCaptureZoneStatus, _groupId)
                CaucasusPendulum.radioMenusAdded[tostring(_groupId)] = true
              end
          end
        end
    end
end

-- reschedule for users that change slot or coalition
RADIO_FREQUENCIES_MENU_SCHEDULER = SCHEDULER:New(nil,
  function()
    -- ADD MENUS FOR RED
    CaucasusPendulum.addRadioMenus(1)
    -- ADD MENUS FOR BLUE
    CaucasusPendulum.addRadioMenus(2)
  end, {}, 0, 60, 0 )

env.info("Syria Pendulum RADIO FREQUENCIES FUNCTIONS loaded ...")
trigger.action.outText("Syria Pendulum RADIO FREQUENCIES FUNCTIONS loaded ...", 10)

-- SCORING ***************************************************************************************

CaucasusPendulumScore = SCORING:New( "Caucasus Pendulum" )
CaucasusPendulumScore:SetScaleDestroyScore( 100 )
CaucasusPendulumScore:SetScaleDestroyPenalty( 200 )
CaucasusPendulumScore:SetMessagesHit( false )
CaucasusPendulumScore:SetMessagesDestroy( true )
CaucasusPendulumScore:SetMessagesToAll( true )
CaucasusPendulumScore:AddZoneScore(GaliZone, 20)
CaucasusPendulumScore:AddZoneScore(SukhumiZone, 20)
CaucasusPendulumScore:AddZoneScore(GudautaZone, 20)
CaucasusPendulumScore:AddZoneScore(ZONE:FindByName("BLUE COMMAND POST ZONE1"), 50)
CaucasusPendulumScore:AddZoneScore(ZONE:FindByName("BLUE COMMAND POST ZONE2"), 50)
CaucasusPendulumScore:AddZoneScore(ZONE:FindByName("BLUE COMMAND POST ZONE3"), 50)
CaucasusPendulumScore:AddZoneScore(ZONE:FindByName("BLUE COMMAND POST ZONE4"), 50)
CaucasusPendulumScore:AddZoneScore(ZONE:FindByName("BLUE COMMAND POST ZONE5"), 50)
CaucasusPendulumScore:AddZoneScore(ZONE:FindByName("BLUE COMMAND POST ZONE6"), 50)
CaucasusPendulumScore:AddZoneScore(ZONE:FindByName("RED BARRACKS ZONE1"), 50)
CaucasusPendulumScore:AddZoneScore(ZONE:FindByName("RED BARRACKS ZONE2"), 50)
CaucasusPendulumScore:AddZoneScore(ZONE:FindByName("RED BARRACKS ZONE3"), 50)
CaucasusPendulumScore:AddZoneScore(ZONE:FindByName("RED BARRACKS ZONE4"), 50)
CaucasusPendulumScore:AddZoneScore(ZONE:FindByName("RED BARRACKS ZONE5"), 50)
CaucasusPendulumScore:AddZoneScore(ZONE:FindByName("RED BARRACKS ZONE6"), 50)

env.info("Syria Pendulum SCORING loaded ...")
trigger.action.outText("Syria Pendulum SCORING loaded ...", 10)

-- END ***************************************************************************************

-- Mission timer chat
RESTART_NOTICE_SCHEDULER = SCHEDULER:New(nil,
  function()
    timeSecs = timer.getAbsTime() - timer.getTime0()
	timeLeft = 28700 - timeSecs
	timeLeftMinutesTotal = math.floor((timeLeft / 60.0))
	timeLeftHours = math.floor((timeLeftMinutesTotal / 60.0))
	timeLeftMinutes = math.floor(((timeLeft - (timeLeftHours*60.0*60.0)) / 60.0))
	if (timeLeftMinutesTotal > 60) then
      env.info("Round time left: " .. timeLeftHours .. " hours " .. timeLeftMinutes .. " minutes.")
      trigger.action.outText("Round time left: " .. timeLeftHours .. " hours " .. timeLeftMinutes .. " minutes.", 10)
      env.info("Live map, SRS and Discord at http://dcs.sofurry.com")
      trigger.action.outText("Live map, SRS and Discord at http://dcs.sofurry.com", 10)
	end
  end, {}, 0, 900, 0 )

RESTART_NOTICE_FINAL_SCHEDULER = SCHEDULER:New(nil,
  function()
    timeSecs = timer.getAbsTime() - timer.getTime0()
	timeLeft = 28700 - timeSecs
	timeLeftMinutesTotal = math.floor((timeLeft / 60.0))
	timeLeftHours = math.floor((timeLeftMinutesTotal / 60.0))
	timeLeftMinutes = math.floor(((timeLeft - (timeLeftHours*60.0*60.0)) / 60.0))
	if (timeLeftMinutesTotal < 60 and timeLeftMinutesTotal > 0) then
      env.info("NOTICE: Round ends in " .. timeLeftHours .. " hours " .. timeLeftMinutes .. " minutes.")
      trigger.action.outText("NOTICE: Round ends in " .. timeLeftHours .. " hours " .. timeLeftMinutes .. " minutes.", 10)
      env.info("Live map, SRS and Discord at http://dcs.sofurry.com")
      trigger.action.outText("Live map, SRS and Discord at http://dcs.sofurry.com", 10)
	end
  end, {}, 0, 300, 0 )

env.info("Syria Pendulum RADIO FREQUENCIES FUNCTIONS loaded ...")
trigger.action.outText("Syria Pendulum RADIO FREQUENCIES FUNCTIONS loaded ...", 10)



env.info("Syria Pendulum loaded OK ...")
trigger.action.outText("Syria Pendulum loaded OK ...", 10)